EDIT - bug #9149

NPE when saving hybrid formula
07/14/2020 12:06 PM - Andreas Mller

Status: Duplicate Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 10%
Category: taxeditor Estimated time: 0:00 hour

Target version:

Severity: normal Found in Version:

Description

last remote method : http://localhost:65480/remoting/taxonnode.service
last remote request client time : 2020-07-08T16:09:31.218

last remote request response header time : Wed, 8 Jul 2020 16:09:31 +0200
client error time : 2020-07-08T16:09:31.565

login : admin
editor version : 5.17.0.202007081029
server : localhost (localhost mgd.) / Cyprus production

schema version : 5.15.2.0.20200611
os : Windows Server 2012 R2 6.3 amd64
java : 1.8.0_121
org.eclipse.ed.core.di.InjectionException: java.lang.NullPointerException
at org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor. java:65

at org.eclipse.ed.core.internal.di.InjectorImpl.invokeUsingClass (InjectorImpl. java
:282)

at org.eclipse.ed.core.internal.di.InjectorImpl.invoke (InjectorImpl.java:247)

at org.eclipse.ed.core.contexts.ContextInjectionFactory.invoke (ContextInjectionFac
tory.java:90)

at org.eclipse.e4d.ui.internal.workbench.PartServiceSaveHandler.save (PartServiceSav
eHandler. java:57)

at org.eclipse.ui.internal.WorkbenchWindow$7.save (WorkbenchWindow. java:594)

at org.eclipse.ed.ui.internal.workbench.PartServiceImpl.savePart (PartServiceImpl.j

ava:1390)

at eu.etaxonomy.taxeditor.workbench.SaveHandler.execute (SaveHandler. java:38)

at sun.reflect.GeneratedMethodAccessor438.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. ja
va:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor. java:55
)

at org.eclipse.ed.core.internal.di.InjectorImpl.invokeUsingClass (InjectorImpl. java
:282)

at org.eclipse.ed.core.internal.di.InjectorImpl.invoke (InjectorImpl. java:264)

at org.eclipse.ed.core.contexts.ContextInjectionFactory.invoke (ContextInjectionFac
tory.java:132)

at org.eclipse.e4d.core.commands.internal.HandlerServiceHandler.execute (HandlerServ
iceHandler. java:152)

at org.eclipse.core.commands.Command.executeWithChecks (Command. java:494)

at org.eclipse.core.commands.ParameterizedCommand.executeWithChecks (ParameterizedC
ommand. java:488)

at org.eclipse.ed.core.commands.internal.HandlerServiceImpl.executeHandler (Handler
ServicelImpl. java:210)

at org.eclipse.e4d.ui.workbench.renderers.swt.HandledContributionItem.executeltem (H
andledContributionItem. java:433)

at org.eclipse.ed.ui.workbench.renderers.swt.AbstractContributionItem.handleWidget
Selection (AbstractContributionItem. java:454)

at org.eclipse.ed.ui.workbench.renderers.swt.AbstractContributionItem$3.handleEven
t (AbstractContributionlItem. java:482)

at org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)

at org.eclipse.swt.widgets.Display.sendEvent (Display.java:4418)

at org.eclipse.swt.widgets.Widget.sendEvent (Widget. java:1079)
at org.eclipse.

at org.eclipse.

at org.eclipse.
gEngine. java:1121)

at org.eclipse.

at org.eclipse.
ngine.java:1022)

at org.eclipse.
at org.eclipse.

at org.eclipse.

at org.eclipse.

at org.eclipse.

at eu.etaxonomy

at org.eclipse.

at org.eclipse.
at org.eclipse.
uncher. java:104)

at org.eclipse.

at org.eclipse.

at sun.reflect.

at sun.reflect.

at sun.reflect.
va:43)

at java.lang.re

at org.eclipse.

at org.eclipse.

at org.eclipse.
Caused by: java.lang.NullPointe
swt.widgets.Display.runDeferredEvents (Display. java:4236)
swt.widgets.Display.readAndDispatch (Display. java:3824)
ed.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderin

core.databinding.observable.Realm.runWithDefault (Realm. java:336)
e4.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingE

e4.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. jav

ui.internal.Workbench$5.run (Workbench. java:693)
core.databinding.observable.Realm.runWithDefault (Realm. java:336)
ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)
ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)
.taxeditor.Application.start (Application. java:20)
equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196

core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (Ecl
core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLa

core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:388)
core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:243)
NativeMethodAccessorImpl.invokeO (Native Method)
NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. ja

flect.Method.invoke (Method. java:498)
equinox.launcher.Main.invokeFramework (Main. java:673)
equinox.launcher.Main.basicRun (Main. java:610)
equinox.launcher.Main.run (Main. java:1519)

rException
cdm.strategy.cache.name.TaxonNameDefaultCacheStrategy.getTaggedNam
java:448)
cdm.strategy.cache.name.TaxonNameDefaultCacheStrategy.getTaggedNam
Jjava:466)
.cdm.strategy.cache.name.NameCacheStrategyBase.getNameCache (NameCac

cdm.model.name.TaxonName.generateNameCache (TaxonName. java:1917)
.cdm.model .name.TaxonName.getNameCache (TaxonName. java:1939)
cdm.persistence.hibernate.CdmPreDataChangelistener.generateCaches (
17)
.cdm.persistence.hibernate.CacheStrategyGenerator.saveOrUpdateOrMer
48)
.cdm.persistence.hibernate.CacheStrategyGenerator.onSaveOrUpdate (Ca

e.internal.SessionImpl.fireSaveOrUpdate (SessionImpl. java:648)
e.internal.SessionImpl.saveOrUpdate (SessionImpl. java:640)
e.engine.spi.CascadingActions$5.cascade (CascadingActions. java:218)
e.engine.internal.Cascade.cascadeToOne (Cascade. java:398)
e.engine.internal.Cascade.cascadeAssociation (Cascade. java:323)
e.engine.internal.Cascade.cascadeProperty (Cascade. java:162)
e.engine.internal.Cascade.cascade (Cascade.java:111)
e.event.internal.AbstractFlushingEventListener.cascadeOnFlush (Abstr
50)
e.event.internal.AbstractFlushingEventListener.prepareEntityFlushes
Java:141)
e.event.internal.AbstractFlushingEventListener.flushEverythingToExe
stener. java:74)
e.event.internal.DefaultFlushEventListener.onFlush (DefaultFlushEven

e.internal.SessionImpl.flush(SessionImpl.java:1282)
e.internal.SessionImpl.managedFlush (SessionImpl. java:465)
e.internal.SessionImpl.flushBeforeTransactionCompletion (SessionImpl

e.internal.SessionImpl.beforeTransactionCompletion (SessionImpl. java

e.engine. jdbc.internal.JdbcCoordinatorImpl.beforeTransactionComplet
ion (JdbcCoordinatorImpl. java:485)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourceLocalTrans
actionCoordinatorImpl.beforeCompletionCallback (JdbcResourcelocalTransactionCoordinatorImpl. java:14
7)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelLocalTrans
actionCoordinatorImpl.access$100 (JdbcResourcelLocalTransactionCoordinatorImpl. java:38)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelLocalTrans
actionCoordinatorImplS$TransactionDriverControlImpl.commit (JdbcResourceLocalTransactionCoordinatorI
mpl.java:231)

at org.hibernate.engine.transaction.internal.TransactionImpl.commit (TransactionImp
1.java:65)

at org.springframework.orm.hibernate5.HibernateTransactionManager.doCommit (Hiberna
teTransactionManager. java:581)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.proc
essCommit (AbstractPlatformTransactionManager.java:761)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.comm
it (AbstractPlatformTransactionManager. java:730)

at org.springframework.transaction.interceptor.TransactionAspectSupport.commitTran
sactionAfterReturning(TransactionAspectSupport. java:485)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWith
inTransaction (TransactionAspectSupport.java:291)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (Trans
actionInterceptor. java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (Reflective
MethodInvocation. java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.

java:208)

at com.sun.proxy.S$Proxyl93.merge (Unknown Source)

at sun.reflect.GeneratedMethodAccessor344.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. ja
va:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtil
s.java:302)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (Re
flectiveMethodInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (Reflective
MethodInvocation. java:157)

at org.springframework.remoting.support.RemoteInvocationTracelnterceptor.invoke (Re
moteInvocationTracelnterceptor.java:78)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (Reflective
MethodInvocation. java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.

java:208)

at com.sun.proxy.S$Proxy305.merge (Unknown Source)

at sun.reflect.GeneratedMethodAccessor446.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. ja
va:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.remoting.support.RemoteInvocation.invoke (RemotelInvocation.j
ava:212)

at eu.etaxonomy.cdm.api.remoting.DebuggingRemoteInvocationExecutor.invoke (Debuggin
gRemoteInvocationExecutor. java:52)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invoke (Remot
eInvocationBasedExporter. java:78)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invokeAndCre
ateResult (RemoteInvocationBasedExporter.java:114)

at org.springframework.remoting.httpinvoker.HttpInvokerServiceExporter.handleReque
st (HttpInvokerServiceExporter. java:74)

at org.springframework.web.servlet.mvc.HttpRequestHandlerAdapter.handle (HttpReques
tHandlerAdapter. java:51)

at org.springframework.web.servlet.DispatcherServlet.doDispatch (DispatcherServlet.

java:959)

at org.springframework.web.servlet.DispatcherServlet.doService (DispatcherServlet.j
ava:893)

at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServle
t.java:969)
at org.springframework.web.servlet.FrameworkServlet.doPost (FrameworkServlet. java:8

71)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:707)

at org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet. java:
845)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse.jetty.servlet.ServletHolder$SNotAsyncServlet.service (ServletHolder.j
ava:1395)

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder. java:755)

at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. ja
va:1617)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:316)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.inv
oke (FilterSecurityInterceptor. java:126)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doF
ilter(FilterSecurityInterceptor. java:90)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (Exc
eptionTranslationFilter. java:114)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.session.SessionManagementFilter.doFilter (Sessi
onManagementFilter.java:122)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.servletapi.SecurityContextHolderAwareRequestFi
lter.doFilter (SecurityContextHolderAwareRequestFilter.java:169)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.savedrequest.RequestCacheAwareFilter.doFilter (
RequestCacheAwareFilter. java:48)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.authentication.www.BasicAuthenticationFilter.d
oFilterInternal (BasicAuthenticationFilter. java:213)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilt
er.java:107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy. java:330)

at org.springframework.security.web.authentication.logout.LogoutFilter.doFilter (Lo
goutFilter.java:120)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.header.HeaderWriterFilter.doFilterInternal (Hea
derWriterFilter. java:64)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilt
er.java:107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.context.SecurityContextPersistenceFilter.doFil
ter (SecurityContextPersistenceFilter.java:91)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.context.request.async.WebAsyncManagerIntegrati
onFilter.doFilterInternal (WebAsyncManagerIntegrationFilter. java:53)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilt
er.java:107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (F
ilterChainProxy.java:330)

at org.springframework.security.web.FilterChainProxy.doFilterInternal (FilterChainP
roxy.java:213)

at org.springframework.security.web.FilterChainProxy.doFilter (FilterChainProxy.jav
a:170)

at org.springframework.web.filter.DelegatingFilterProxy.invokeDelegate (DelegatingF
ilterProxy.java:346)
org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. ja

eu.etaxonomy.cdm.servlet .DateHeaderFilter.doFilter (DateHeaderFilter. java:55)

org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. ja

at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal (Charact
er.java:107)

at
va:1596)

at

at

at

at

at

at

at

at

at

at
at

at

at

at

at

at

at

at

at

at

at
on.java:311)

at

at

at
va:336)

at
java:313)

at
.java:171)

at
29)

at

org

org.

org.
.eclipse.

org

org.
org.

org

org.

org.

org

org.

org.
org.

org.

org

org.
org.
org.
org.
.eclipse.

org

org.
org.

org

org.
org.
org.

org

org.

org.

org

.eclipse.

.eclipse.

.eclipse.

.eclipse.

dThreadExecutor. java:388)

at org.eclipse.

at org.eclipse.

:938)

eclipse.
eclipse.
eclipse.
.eclipse.

eclipse.

eclipse.

eclipse.

eclipse.
eclipse.

eclipse.

eclipse.
eclipse.
eclipse.
eclipse.

eclipse.
eclipse.
.eclipse.
eclipse.

eclipse.
eclipse.

eclipse.

eclipse.

eclipse. jetty.
jetty.
jetty.
Jetty.
Jetty.
Jetty.
jetty.
jetty.
Jetty.

Jetty.

jetty.
jetty.

jetty.
Jetty.
Jetty.
jetty.
jetty.
jetty.
jetty.
Jetty.
Jetty.
Jetty.
jetty.
jetty.
jetty.
Jetty.
Jetty.
jetty.

jetty.

Jetty.

Jetty

util

.util.

server
server

server

server

S(SIaVASS

server

SRV EIL o
server
server.
server
server.
server.
SCHavENS

Server.
server

util.

util.

util.

util.

thread

thread.

thread.

.thread

thread.

thread.

thread

servlet.ServletHandler$CachedChain.doFilter (ServletHandler. ja

servlet.ServletHandler.doHandle (ServletHandler. java:545)
server.handler.ScopedHandler.handle (ScopedHandler. java:143)
security.SecurityHandler.handle (SecurityHandler. java:590)
.handler.HandlerWrapper.handle (HandlerWrapper. java:127)
.handler.ScopedHandler.nextHandle (ScopedHandler. java:23

.session.SessionHandler.doHandle (SessionHandler. java:16

.handler.ScopedHandler.nextHandle (ScopedHandler. java:23

.handler.ContextHandler.doHandle (ContextHandler. java:12

.handler.ScopedHandler.nextScope (ScopedHandler. java:188

servlet.ServletHandler.doScope (ServletHandler. java:485)
server.session.SessionHandler.doScope (SessionHandler. java:157

handler.ScopedHandler.nextScope (ScopedHandler. java:186

.handler.ContextHandler.doScope (ContextHandler.java:121

handler.ScopedHandler.handle (ScopedHandler. java:141)
.handler.HandlerWrapper.handle (HandlerWrapper.java:127)
Server.handle (Server. java:500)
HttpChannel.lambda$handle$1l (HttpChannel. java:383)
.HttpChannel.dispatch (HttpChannel. java:547)
HttpChannel.handle (HttpChannel. java:375)
.HttpConnection.onFillable (HttpConnection. java:270)
io.AbstractConnection$ReadCallback.succeeded (AbstractConnecti

io.FillInterest.fillable(FillInterest.java:103)
io.ChannelEndPoint$2.run (ChannelEndPoint.java:117)
util.

.strategy.EatWhatYouKill.runTask (EatWhatYouKill. ja
strategy.EatWhatYouKill.doProduce (EatWhatYouKill.
strategy.EatWhatYouKill.tryProduce (EatWhatYouKill
.strategy.EatWhatYouKill.run (EatWhatYouKill. java:1l
ReservedThreadExecutor$ReservedThread. run (Reserve
QueuedThreadPool.runJob (QueuedThreadPool. java:806

.QueuedThreadPool$Runner.run (QueuedThreadPool. java

at java.lang.Thread.run (Thread. java:745)
at org.springframework.remoting.support.RemoteInvocationUtils.fillInClientStackTra

celfPossible (RemoteInvocationUtils. java:45)

at org.springframework.remoting.support.RemoteInvocationResult.recreate (RemotelInvo

cationResult.java:149)

at org.springframework.remoting.support.RemoteInvocationBasedAccessor.recreateRemo
teInvocationResult (RemoteInvocationBasedAccessor. java:85)
at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (Ht
tpInvokerClientInterceptor. java:150)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (Reflective

MethodInvocation. java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.

at eu.etaxonomy.taxeditor.editor.ed.TaxonEditorInputE4.merge (TaxonEditorInputE4. ja

at eu.etaxonomy.taxeditor.editor.name.e4d.TaxonNameEditorE4.save (TaxonNameEditorE4.

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. ja

java:208)
at com.sun.proxy.S$SProxy345.merge (Unknown Source)
va:424)
java:419)
at sun.reflect.GeneratedMethodAccessor442.invoke (Unknown Source)
va:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.e4d.core.internal.di.MethodRequestor.execute (MethodRequestor. java:55

47 more

Related issues:
Is duplicate of EDIT - bug #9360: Parsed hybrids can not be persisted

Feedback

History

#1 - 07/14/2020 12:47 PM - Andreas Miiller
- % Done changed from 0 to 10

This happens during merge on server side. The parent names do not have any data at some time when getTitleCache is called on children.

This is strange because the merged taxon name's parents do have the correct state.

It looks like getTitleCache on child is called before the server side parents are filled with any data. This causes the problem.

Is it correct to handle the titleCaches in a PreDataChangelListener?
Needs further research.

#2 - 01/23/2021 02:46 AM - Andreas Miiller
- Related to bug #9360: Parsed hybrids can not be persisted added

#3 - 01/26/2021 12:33 PM - Andreas Miiller

- Target version changed from Release 5.18 to Release 5.19

#4 - 01/26/2021 12:43 PM - Andreas Miiller
- Status changed from New to Duplicate
- Priority changed from New to Highest

- Target version deleted (Release 5.19)

#5 - 01/26/2021 12:43 PM - Andreas Miiller
- Related to deleted (bug #9360: Parsed hybrids can not be persisted)

#6 - 01/26/2021 12:43 PM - Andreas Miiller
- Is duplicate of bug #9360: Parsed hybrids can not be persisted added
